use psrchive;
-- Use the following file to create a temporary s70 table based on a csv file
--  produced by running pvosummary -c in the $S70V directory.
source /DATA/SITAR_1/whi550/VO/PulsarVO/sql/create_table_s70.sql;
--
-- Performing a conesearch around position RA=0.=00:00:00 and DEC=-43.=-43:00:00 for the S70 data
-- This should pick up three files from the new batch added on June 26.
-- The old query of RA=0 and DEC=-49 should pick up four files.
SET @qra=0., @qdec=-49.;
SELECT filename, raj, decj, 0.5*(bmaj+bmin) as beamsize, obsfreq, scanlen,
(degrees( acos( cos(radians(rajd-@qra))*cos(radians(decjd))*cos(radians(@qdec))+sin(radians(decjd))*sin(radians(@qdec)) ) )) as angsep
FROM s70
WHERE (degrees( acos( cos(radians(rajd-@qra))*cos(radians(decjd))*cos(radians(@qdec))+sin(radians(decjd))*sin(radians(@qdec)) ) ) - 0.25*(bmaj+bmin) ) <  1.
ORDER by angsep;
-- period;
